#include <opencv2/opencv.hpp>
#include "Windows.h"
#include <iostream>
#include "EV3.hpp"

#define KEY_DOWN(key) (GetAsyncKeyState(key)&0x8000)
#define KEY_PUSH(key) (GetAsyncKeyState(key)&0x8001)

using namespace cv;

VideoCapture video;

Mat image;

Mat imege_ball;

Mat imege_bot;

Mat imagecvt;

Mat imagecvt_2;

Mat imege1;

Mat camera;

int cut_y_u = 0;
int cut_x_l = 0;
int cut_y_d = 0;
int cut_x_r = 0;
int bey = 0;

int counter_ball = 0;
Point cur_point_m;
Point robot;

int low_Hb = 0, low_Sb = 184, low_Vb = 106;
int high_Hb = 8, high_Sb = 249, high_Vb = 172;


int low_Hr = 31, low_Sr = 17, low_Vr = 116;
int high_Hr = 83, high_Sr = 185, high_Vr = 163;

bool kick = false;

int speed;

void hsv_red1(int event, int x, int y, int flags, void* userdata)
{
	if (event == EVENT_LBUTTONDOWN)
	{
		Vec3b t = imege_ball.at<Vec3b>(y, x);
		std::cout << imege_ball.at<Vec3b>(y, x);
	}
}

int main() {
	EV3 Ev3;
	Ev3.connect(9);

	video.open(1);
	namedWindow("Original Video", WINDOW_AUTOSIZE);
	namedWindow("Ori", WINDOW_AUTOSIZE);
	namedWindow("Itog", WINDOW_AUTOSIZE);
	int kick_count = 0;

	while (!KEY_PUSH(VK_ESCAPE)) {
		video >> camera;
		if (camera.empty()) break;

		imege_bot = camera;
		imagecvt_2 = camera;

		cut_y_d = 30;
		cut_y_u = 100;
		cut_x_l = 50;
		cut_x_r = 90;
		camera = camera(Range(0 + cut_y_u, 480 - cut_y_d), Range(0 + cut_x_l, 640 - cut_x_r));
		imshow("Original Video", camera);


		cvtColor(camera, imagecvt_2, COLOR_BGR2HSV);
		inRange(imagecvt_2, Scalar(low_Hb, low_Sb, low_Vb), Scalar(high_Hb, high_Sb, high_Vb), imagecvt_2);

		cvtColor(camera, imege_bot, COLOR_BGR2HSV);
		inRange(imege_bot, Scalar(low_Hr, low_Sr, low_Vr), Scalar(high_Hr, high_Sr, high_Vr), imege_bot);
		imshow("Ori", imege_bot);

		imege1 = imagecvt_2;
		imshow("Itog", imege1);
		
		if (counter_ball == 3) {
			counter_ball = 0;
			Moments m = moments(imege1);
			Point old_point_m = cur_point_m;
			cur_point_m = Point(static_cast<float>(m.m10 / m.m00 + 1e-5), static_cast<float>(m.m01 / m.m00 + 1e-5));
			Moments m_bot = moments(imege_bot);
			robot = Point(static_cast<float>(m_bot.m10 / m_bot.m00 + 1e-5), static_cast<float>(m_bot.m01 / m_bot.m00 + 1e-5));
			if ((cur_point_m.x - old_point_m.x) > 0 && (cur_point_m.y - old_point_m.y) > 0) {
				int old_x = old_point_m.x;
				int old_y = old_point_m.y;
				int cur_x = cur_point_m.x;
				int cur_y = cur_point_m.y;
				int a = (cur_y - old_y) / (old_x - cur_x);
				int b = old_y - (cur_y - old_y) / (old_x - cur_x) * cur_x;
				int bot_x = (400 - b) / a;
				if (bot_x < 0) {
					bot_x = 0 - bot_x;
					if (bot_x < 180) {
						bot_x = 180;
					}
				}
				if (bot_x > 500) {
					bot_x = 500 - (bot_x - 500);
					if (bot_x > 535) {
						bot_x = 535;
					}
				}
				robot.x = bot_x;
				if (abs(robot.x - static_cast<float>(m_bot.m10 / m_bot.m00 + 1e-5)) < 30) {
					speed = 0;
					int error_cic = robot.y - cur_point_m.y;
					if (abs(error_cic) < 30) {
						Ev3.motor(EV3::MOTOR_B, 0);
						Ev3.motor(EV3::MOTOR_C, 0);
						kick = true;
					}
				}
				else {
					if (robot.x > static_cast<float>(m_bot.m10 / m_bot.m00 + 1e-5)) {
						speed = -70;
					}
					else {
						speed = 70;
					}
				}
			}


		}
		
		if (kick and kick_count <= 5) {
			kick_count++;
			Ev3.motor(EV3::MOTOR_A, 100);
			Ev3.motor(EV3::MOTOR_D, 100);
		}
		if (kick and kick_count > 5 and kick_count <= 15) {
			kick_count++;
			Ev3.motor(EV3::MOTOR_A, -30);
			Ev3.motor(EV3::MOTOR_D, -30);
		}
		if (kick and kick_count > 15) {
			kick_count = 0;
			kick = false;
			Ev3.motor(EV3::MOTOR_A, 0);
			Ev3.motor(EV3::MOTOR_D, 0);
		}
		Ev3.motor(EV3::MOTOR_B, speed);
		Ev3.motor(EV3::MOTOR_C, speed);

		circle(camera, cur_point_m, 5, Scalar(255, 255, 0), -1);
		circle(camera, robot, 5, Scalar(0, 255, 0), -1);
		imshow("Original Video", camera);

		waitKey(1);
		counter_ball ++;
	}
	return 0;
}